// This is a scripted coppercube action.
// It does an action after a while and exit before the time interval if signal received.
// Modified Version of Do Later Script Created by : N. Gebhardt.
// Modified by : Ahmed ABDEL SALAM (techno-valley)
// 
/*
	<action jsname="action_DoLaterExitOnSignal" description="Do something - Follow Signal">
		<property name="TimeMs" type="int" default="500" />
		<property name="ActionToDo" type="action" />
		<property name="VarWatchDog" type="string" Default="Signal" />
	</action>
*/

action_DoLaterExitOnSignal = function()
{
};


// called when the action is executed 
action_DoLaterExitOnSignal.prototype.execute = function(currentNode)
{
	var me = this; 
	this.registeredFunction = function() { me.doLaterFunc(); }; 
	
	ccbRegisterOnFrameEvent(this.registeredFunction);	
	
	this.startTime = (new Date()).getTime();
	this.endTime = this.startTime + this.TimeMs;
	this.currentNode = currentNode;
}


action_DoLaterExitOnSignal.prototype.doLaterFunc = function()
{
	var now = (new Date()).getTime();
	
	if (now > this.endTime || ccbGetCopperCubeVariable(this.VarWatchDog) == 1)
	{
		ccbInvokeAction(this.ActionToDo, this.registeredFunction);
		ccbUnregisterOnFrameEvent(this.registeredFunction);
		this.startTime = 0;
		this.endTime = 0;
		ccbSetCopperCubeVariable(this.VarWatchDog,0);
	}
}
